Subject: Re: bug#25930: optimize mv for multiple bind mounts

From: Assaf Gordon <[email-masked]>
Date: Sun, 28 Oct 2018 20:50:17 -0600

close 25930
stop

(triaging old bugs)

On 2017-03-04 1:01 a.m., Sven Joachim wrote:
> On 2017-03-02 13:16 -0800, L A Walsh wrote:
> 
>> Sven Joachim wrote:
>>> ,----
>>> |   EXDEV  oldpath and newpath are not on the same mounted filesystem.
>>> |          (Linux  permits  a  filesystem  to  be  mounted at multiple
>>> |          points, but rename() does not work across  different  mount
>>> |          points, even if the same filesystem is mounted on both.)
>>>    
>> ----
>>     That's unfortunate, as Windows recognizes moves between
>> the same device and does a rename vs. a copy (i.e. it doesn't
>> matter if the mounted object from the mount is different, as
>> long as the rename happens between the same devices).
> 
> Linux used to do the same in kernel 2.2, but changed the behavior when
> bind mounts were introduced in 2.4.0.  In other words, it's deliberate.
> 

Given the above (kernel limitation), I'm closing this bug.
Discussion can continue by replying to this thread.

-assaf